/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 */

package com.huawei.agc.flutter.appmessaging.handlers;

import android.app.Activity;

import androidx.annotation.NonNull;

import com.huawei.agc.flutter.appmessaging.utils.Utils;
import com.huawei.agconnect.AGConnectInstance;
import com.huawei.agconnect.appmessaging.AGConnectAppMessaging;
import com.huawei.agconnect.appmessaging.AGConnectAppMessagingOnClickListener;
import com.huawei.agconnect.appmessaging.model.Action;
import com.huawei.agconnect.appmessaging.model.AppMessage;

import io.flutter.plugin.common.EventChannel.EventSink;
import io.flutter.plugin.common.EventChannel.StreamHandler;

public class AGCAppMessagingOnMessageClickStreamHandler implements StreamHandler {

    public AGCAppMessagingOnMessageClickStreamHandler(final Activity activity) {
        if (AGConnectInstance.getInstance() == null) {
            AGConnectInstance.initialize(activity.getApplicationContext());
        }
    }

    @Override
    public void onListen(final Object arguments, final EventSink eventSink) {
        AGConnectAppMessaging.getInstance().addOnClickListener(new AGConnectAppMessagingOnClickListener() {
            @Override
            public void onMessageClick(@NonNull AppMessage appMessage, @NonNull Action action) {
                eventSink.success(Utils.fromAppMessageToMap(appMessage));
            }
        });
    }

    @Override
    public void onCancel(final Object arguments) {
    }
}
